module Gemnigma
  class Messages
    def initialize(io=$stdout)
      @io = io
    end

    def puts(msg)
      @io.puts msg
    end

    def few_args
      puts "Not enough arguments passed in. Run Gemnigma --help for instructions on usage\nExiting..."
    end

    def too_much_args
      puts "Too many arguments passed in. Run Gemnigma --help for instructions on usage\nExiting..."
    end

    def file_not_in_existence(file)
      puts "#{file}: File does not exist\nExiting..."
    end

    def file_in_existence(input_file, output_file)
      puts "#{input_file} exists... Checking #{output_file}"
    end

    def creating_new_file(file)
      puts "#{file} will be created, proceeding..."
    end

    def overwrite_warning(file)
      puts "#{file} exists already, do you want to overwrite it? (Y) or (N): "
    end

    def wrong_date(date)
      puts "#{date} doesn't match the specified date format\nExiting..."
    end

    def success_message(output_file, key, date)
      puts "\n........................................................"
      puts "\nCreated '#{output_file}' with secret key #{key} and date #{date}"
    end
  end
end