require_relative "messages"

module Gemnigma
  module ValidateFileArg
    def validate
      @input_file = ARGV[1]
      @output_file = ARGV[2]

      unless File.file? @input_file
        Messages.new.file_not_in_existence(@input_file)
        return
      end

      if File.file? @input_file
        Messages.new.file_in_existence(@input_file, @output_file)
        unless File.file? @output_file
          Messages.new.creating_new_file(@output_file)
          yield if block_given?
        else
          Messages.new.overwrite_warning(@output_file)
          user_choice = $stdin.gets.chomp.downcase

          if user_choice == "y"
            yield if block_given?
          elsif user_choice == "n"
            puts "Operation aborted\nExiting..."
            return
          else
            puts "Not a valid choice.\nOperation aborted.\nExiting..."
            return
          end

        end
      end

    end
  end
end